BEGIN {
	# not inside the marker
	marker = 0
	# the map_image not specified
	image_found = 0
	# div tags not created
	divs_created = 0
	# should we wait for WAIT* sting with marker printing
	waiting = 0
}

/-->/ { endmarker() }

END { endmarker() }

{
	if (marker == 1) {
		if (index($0,"MAP_IMAGE") > 0) {
			n = split(substr($0, index($0,"MAP_IMAGE")), A)
			idx=IMAGEORDER+1
			if (n >= idx && A[idx] !~ /-->/) {
				mapimage(A[idx])
			}
		} else {
			printf("<!-- JUST PASSING THROUGH RSTART=%d RLENGTH=%d-->", RSTART, RLENGTH)
			print 
		}
	}
}

/<!--[ \t]+((MAP_MARKER)|(map_marker))/ {

	# the tag does not have to begin the line -> lshift the line and split to A
	n = split(substr($0, match($0,/<!--[ \t]+((MAP_MARKER)|(map_marker))/)), A)
	
	marker=1
	markericon="marker"substr(A[2],11)
	mapdir=A[3]
	x1=A[4]
	y1=A[5]
	id=A[6]
	
	# print the map basename - will be replaced
	printf("%s\n",A[3])

	pos = 7
	# check if WAIT* parameter is present
	if (n >= pos && A[pos] ~ /[Ww][Aa][Ii][Tt].*/) {
		pos = pos + 1
	}

	# check if MAP_IMAGE is on the same line (if NF<7 $7 is null string)
	idx = IMAGEORDER+pos
	if (n >= idx && A[pos] ~ /MAP_IMAGE/ && A[idx] !~ /-->/) {
		mapimage(A[idx])
	}

	# check if the line ends with -->
	if (match($0,/-->/) > match($0,/<!--[ \t]+((MAP_MARKER)|(map_marker))/)) {
		endmarker()
	}
}

# create the div tags for mouse-out and mouse-over state
function create_divs() {
	# calculate pop-up window position (x2,y2)
	if (image_found == 1) {
		x2 = x1 > 600 ? x1-IMAGEWIDTH+10 : x1-25
		y2 = y1 > 400 ? y1-2*IMAGEWIDTH/3+10 : y1-25
	} else {
		x2 = x1
		y2 = y1
	}

	# div tag of the marker - waiting for mouse-over
	printf("<div id='%s_mark'\n", id)
	printf(" style='visibility:visible;position:absolute;")
	printf("left:%dpx;top:%dpx'>\n", x1, y1)
	printf("<a href='%s.%s'", BACKPATH, FILENAME)
	printf(" onMouseOver=\"Swap('%s_mark','%s_full')\">\n", id, id)
	printf("<img id='%s_mark_image' ", id)
	printf("src='%s-off.png' alt='marker'></a>\n</div>\n", markericon);

	# div tag of the image - pops-up on mouse-over
	printf("<div id='%s_full'\n", id)
	printf(" style='visibility:hidden;position:absolute;") 
	printf("left:%dpx;top:%dpx'>\n", x2, y2)
	printf("<table width=%s><tr><td>\n",IMAGEWIDTH) 
	printf("<a href='%s.%s'",BACKPATH,FILENAME) 
	printf(" onMouseOut=\"Swap('%s_full','%s_mark')\">\n", id, id)

	divs_created = 1
}

# MAP_IMAGE found - generate small image, add img tag to div
function mapimage(imagepath) {
	image_found = 1
	if (divs_created == 0) {
		create_divs()
	}

	n = split(imagepath,A,"/")
	if (n > 1) {
		imagefile = A[n]
	} else {
		imagefile = imagepath
	}
	sub("\\.\\*",".jpg",imagefile)
	
	sourceimg = PHOTODIR imagepath
	popupimg = MAPDIR mapdir "/tn/" imagefile
	geometry = IMAGEWIDTH "x" IMAGEWIDTH
	
	# rescale image for pop-up (f it does not exist or is older than source)
	system(sprintf("[ -f %s ] || [ %s -nt %s ] || /usr/bin/convert -geometry %s %s %s",
		popupimg, popupimg, sourceimg, geometry, sourceimg, popupimg))
	printf("<img src='tn/%s'><br>\n",imagefile) 
}

# map_marker tag ends - end the output div tag
function endmarker() {
	if (marker == 1) {
		if (divs_created == 0) {
			create_divs()
		}

		# try to find the title for album and add it to the pop-up
		n = split(FILENAME, B,"/")
		dir = substr(FILENAME,0,length(FILENAME)-length(B[n]))
		gsub("tn/","",dir)	# dir contains tn/ -> link to image -> nevertheless give album caption
		getline title < sprintf("%scaptions.txt",dir)
		title = substr(title,index(title,"\t"))
		gsub(":","<br>",title)
		gsub(",","<br>",title)
		gsub("^[ \t]*","",title)
		print title
		# if title is empty and no image was found, show at least marker
		if (title ~ // && image_found == 0) {
			printf("<img src='../%s-off.png' alt='marker'>\n", markericon);
		}
		printf("</td></tr></table>\n</a></div><!-- END -->\n") 
		marker = 0
		image_found = 0
		divs_created = 0
	}
}

